//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: injective/insurance/v1beta1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the insurance Msg service.
///
/// Usage: instantiate `Injective_Insurance_V1beta1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Injective_Insurance_V1beta1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Injective_Insurance_V1beta1_MsgClientInterceptorFactoryProtocol? { get }

  func createInsuranceFund(
    _ request: Injective_Insurance_V1beta1_MsgCreateInsuranceFund,
    callOptions: CallOptions?
  ) -> UnaryCall<Injective_Insurance_V1beta1_MsgCreateInsuranceFund, Injective_Insurance_V1beta1_MsgCreateInsuranceFundResponse>

  func underwrite(
    _ request: Injective_Insurance_V1beta1_MsgUnderwrite,
    callOptions: CallOptions?
  ) -> UnaryCall<Injective_Insurance_V1beta1_MsgUnderwrite, Injective_Insurance_V1beta1_MsgUnderwriteResponse>

  func requestRedemption(
    _ request: Injective_Insurance_V1beta1_MsgRequestRedemption,
    callOptions: CallOptions?
  ) -> UnaryCall<Injective_Insurance_V1beta1_MsgRequestRedemption, Injective_Insurance_V1beta1_MsgRequestRedemptionResponse>
}

extension Injective_Insurance_V1beta1_MsgClientProtocol {
  internal var serviceName: String {
    return "injective.insurance.v1beta1.Msg"
  }

  /// CreateInsuranceFund defines a method for creating an insurance fund
  ///
  /// - Parameters:
  ///   - request: Request to send to CreateInsuranceFund.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func createInsuranceFund(
    _ request: Injective_Insurance_V1beta1_MsgCreateInsuranceFund,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Injective_Insurance_V1beta1_MsgCreateInsuranceFund, Injective_Insurance_V1beta1_MsgCreateInsuranceFundResponse> {
    return self.makeUnaryCall(
      path: "/injective.insurance.v1beta1.Msg/CreateInsuranceFund",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeCreateInsuranceFundInterceptors() ?? []
    )
  }

  /// Underwrite defines a method for depositing tokens to underwrite an insurance fund
  ///
  /// - Parameters:
  ///   - request: Request to send to Underwrite.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func underwrite(
    _ request: Injective_Insurance_V1beta1_MsgUnderwrite,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Injective_Insurance_V1beta1_MsgUnderwrite, Injective_Insurance_V1beta1_MsgUnderwriteResponse> {
    return self.makeUnaryCall(
      path: "/injective.insurance.v1beta1.Msg/Underwrite",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeUnderwriteInterceptors() ?? []
    )
  }

  /// RequestRedemption defines a method for requesting a redemption of the sender's insurance fund tokens
  ///
  /// - Parameters:
  ///   - request: Request to send to RequestRedemption.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func requestRedemption(
    _ request: Injective_Insurance_V1beta1_MsgRequestRedemption,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Injective_Insurance_V1beta1_MsgRequestRedemption, Injective_Insurance_V1beta1_MsgRequestRedemptionResponse> {
    return self.makeUnaryCall(
      path: "/injective.insurance.v1beta1.Msg/RequestRedemption",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRequestRedemptionInterceptors() ?? []
    )
  }
}

internal protocol Injective_Insurance_V1beta1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'createInsuranceFund'.
  func makeCreateInsuranceFundInterceptors() -> [ClientInterceptor<Injective_Insurance_V1beta1_MsgCreateInsuranceFund, Injective_Insurance_V1beta1_MsgCreateInsuranceFundResponse>]

  /// - Returns: Interceptors to use when invoking 'underwrite'.
  func makeUnderwriteInterceptors() -> [ClientInterceptor<Injective_Insurance_V1beta1_MsgUnderwrite, Injective_Insurance_V1beta1_MsgUnderwriteResponse>]

  /// - Returns: Interceptors to use when invoking 'requestRedemption'.
  func makeRequestRedemptionInterceptors() -> [ClientInterceptor<Injective_Insurance_V1beta1_MsgRequestRedemption, Injective_Insurance_V1beta1_MsgRequestRedemptionResponse>]
}

internal final class Injective_Insurance_V1beta1_MsgClient: Injective_Insurance_V1beta1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Injective_Insurance_V1beta1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the injective.insurance.v1beta1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Injective_Insurance_V1beta1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the insurance Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Injective_Insurance_V1beta1_MsgProvider: CallHandlerProvider {
  var interceptors: Injective_Insurance_V1beta1_MsgServerInterceptorFactoryProtocol? { get }

  /// CreateInsuranceFund defines a method for creating an insurance fund
  func createInsuranceFund(request: Injective_Insurance_V1beta1_MsgCreateInsuranceFund, context: StatusOnlyCallContext) -> EventLoopFuture<Injective_Insurance_V1beta1_MsgCreateInsuranceFundResponse>

  /// Underwrite defines a method for depositing tokens to underwrite an insurance fund
  func underwrite(request: Injective_Insurance_V1beta1_MsgUnderwrite, context: StatusOnlyCallContext) -> EventLoopFuture<Injective_Insurance_V1beta1_MsgUnderwriteResponse>

  /// RequestRedemption defines a method for requesting a redemption of the sender's insurance fund tokens
  func requestRedemption(request: Injective_Insurance_V1beta1_MsgRequestRedemption, context: StatusOnlyCallContext) -> EventLoopFuture<Injective_Insurance_V1beta1_MsgRequestRedemptionResponse>
}

extension Injective_Insurance_V1beta1_MsgProvider {
  internal var serviceName: Substring { return "injective.insurance.v1beta1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "CreateInsuranceFund":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Injective_Insurance_V1beta1_MsgCreateInsuranceFund>(),
        responseSerializer: ProtobufSerializer<Injective_Insurance_V1beta1_MsgCreateInsuranceFundResponse>(),
        interceptors: self.interceptors?.makeCreateInsuranceFundInterceptors() ?? [],
        userFunction: self.createInsuranceFund(request:context:)
      )

    case "Underwrite":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Injective_Insurance_V1beta1_MsgUnderwrite>(),
        responseSerializer: ProtobufSerializer<Injective_Insurance_V1beta1_MsgUnderwriteResponse>(),
        interceptors: self.interceptors?.makeUnderwriteInterceptors() ?? [],
        userFunction: self.underwrite(request:context:)
      )

    case "RequestRedemption":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Injective_Insurance_V1beta1_MsgRequestRedemption>(),
        responseSerializer: ProtobufSerializer<Injective_Insurance_V1beta1_MsgRequestRedemptionResponse>(),
        interceptors: self.interceptors?.makeRequestRedemptionInterceptors() ?? [],
        userFunction: self.requestRedemption(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Injective_Insurance_V1beta1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'createInsuranceFund'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeCreateInsuranceFundInterceptors() -> [ServerInterceptor<Injective_Insurance_V1beta1_MsgCreateInsuranceFund, Injective_Insurance_V1beta1_MsgCreateInsuranceFundResponse>]

  /// - Returns: Interceptors to use when handling 'underwrite'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeUnderwriteInterceptors() -> [ServerInterceptor<Injective_Insurance_V1beta1_MsgUnderwrite, Injective_Insurance_V1beta1_MsgUnderwriteResponse>]

  /// - Returns: Interceptors to use when handling 'requestRedemption'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRequestRedemptionInterceptors() -> [ServerInterceptor<Injective_Insurance_V1beta1_MsgRequestRedemption, Injective_Insurance_V1beta1_MsgRequestRedemptionResponse>]
}
